      SUBROUTINE MNA5R(F,N,P,MP,Y,PR,PRR,PBAR,EPS,IREGIM,IFLAG,ITMAX)
      INTEGER IREGIM,IFLAG,ITMAX,N,MP,I,J,ITER,L,MPTS,ILO,IHI,INHI
      REAL F,P,Y,PR,PRR,PBAR,EPS,ALPHA,BETA,GAMMA,ZERO,
     *     ONE,HALF,S1,S2,RTOL,YPR,YPRR
      DIMENSION P(MP,N),Y(MP),PR(N),PRR(N),PBAR(N)
      COMMON/MNA5RR/ITER
      DATA ALPHA/1.0/,BETA/0.5/,GAMMA/2.0/,ZERO/0.0/,
     *     ONE/1.0/,HALF/0.5/,TWO/2.0/
      IFLAG=0
      ITER=0
      MPTS=N+1
      IF(IREGIM.NE.0) GO TO 20
      S1=(SQRT(ONE+N)+N-ONE)/(N*SQRT(TWO))
      S2=(SQRT(ONE+N)-ONE)/(N*SQRT(TWO))
      DO 10 I=2,MPTS
      DO 10 J=1,N
      P(I,J)=S2+P(1,J)
      L=I-1
      P(I,L)=S1+P(1,J)
   10 CONTINUE
   20 DO 40 I=1,MPTS
      DO 30 J=1,N
      PR(J)=P(I,J)
   30 CONTINUE
      Y(I)=F(PR,N)
   40 CONTINUE
   50 ILO=1
      IF(Y(1).LE.Y(2)) GO TO 60
      IHI=1
      INHI=2
      GO TO 70
   60 IHI=2
      INHI=1
   70 DO 90 I=1,MPTS
      IF(Y(I).LT.Y(ILO)) ILO=I
      IF(Y(I).LE.Y(IHI)) GO TO 80
      INHI=IHI
      IHI=I
      GO TO 90
   80 IF(Y(I).LE.Y(INHI)) GO TO 90
      IF(I.NE.IHI) INHI=I
   90 CONTINUE
      RTOL=ABS(Y(IHI)-Y(ILO))
      IF(RTOL.LT.ABS(EPS)) GO TO 280
      IF(ITER.EQ.ITMAX) GO TO 290
      ITER=ITER+1
      DO 100 J=1,N
      PBAR(J)=ZERO
  100 CONTINUE
      DO 120 I=1,MPTS
      IF(I.EQ.IHI) GO TO 120
      DO 110 J=1,N
      PBAR(J)=PBAR(J)+P(I,J)
  110 CONTINUE
  120 CONTINUE
      DO 130 J=1,N
      PBAR(J)=PBAR(J)/N
      PR(J)=(ONE+ALPHA)*PBAR(J)-ALPHA*P(IHI,J)
  130 CONTINUE
      YPR=F(PR,N)
      IF(YPR.GT.Y(ILO)) GO TO 180
      DO 140 J=1,N
      PRR(J)=GAMMA*PR(J)+(ONE-GAMMA)*PBAR(J)
  140 CONTINUE
      YPRR=F(PRR,N)
      IF(YPRR.GE.Y(ILO)) GO TO 160
      DO 150 J=1,N
      P(IHI,J)=PRR(J)
  150 CONTINUE
      Y(IHI)=YPRR
      GO TO 50
  160 DO 170 J=1,N
      P(IHI,J)=PR(J)
  170 CONTINUE
      Y(IHI)=YPR
      GO TO 50
  180 IF(YPR.LT.Y(INHI)) GO TO 260
      IF(YPR.GE.Y(IHI)) GO TO 200
      DO 190 J=1,N
      P(IHI,J)=PR(J)
  190 CONTINUE
      Y(IHI)=YPR
  200 DO 210 J=1,N
      PRR(J)=BETA*P(IHI,J)+(ONE-BETA)*PBAR(J)
  210 CONTINUE
      YPRR=F(PRR,N)
      IF(YPRR.GE.Y(IHI)) GO TO 230
      DO 220 J=1,N
      P(IHI,J)=PRR(J)
  220 CONTINUE
      Y(IHI)=YPRR
      GO TO 50
  230 DO 250 I=1,MPTS
      IF(I.EQ.ILO) GO TO 250
      DO 240 J=1,N
      PR(J)=HALF*(P(I,J)+P(ILO,J))
      P(I,J)=PR(J)
  240 CONTINUE
      Y(I)=F(PR,N)
  250 CONTINUE
      GO TO 50
  260 DO 270 J=1,N
      P(IHI,J)=PR(J)
  270 CONTINUE
      Y(IHI)=YPR
      GO TO 50
  280 IFLAG=1
  290 RETURN
      END 
